function y = rgb_to_ycbcr(x)

  % assume rgb image in which case 'planes' must be 3
  [rows,cols,planes] = size(x);
  x = double(x);

  % y = zeros(rows,cols,3,'uint8');
  y = zeros(rows,cols,3);
  for i = 1:rows
    for j = 1:cols
      rp = x(i,j,1);
      gp = x(i,j,2);
      bp = x(i,j,3);
      yp = 0   + (0.299    * rp) + (0.587    * gp) + (0.114    * bp);
      cb = 128 - (0.168736 * rp) - (0.331264 * gp) + (0.5      * bp);
      cr = 128 + (0.5      * rp) - (0.418688 * gp) - (0.081212 * bp);
      y(i,j,1) = yp;
      y(i,j,2) = cb;
      y(i,j,3) = cr;
    end
  end
end
