% A set cover problem from http://mat.gsia.cmu.edu/orclass/integer/node8.html
% encoded as a {0,1}-programming problem for BLT.
mss_config('default_solver', 'blt');

% main part of the constraint matrix
C = [ 1 1 1 1 0 0 0 0 0 0 0;
      1 1 1 0 1 0 0 0 0 0 0;
      1 1 1 1 1 1 0 0 0 0 0;
      1 0 1 1 0 1 1 0 0 0 0;
      0 1 1 0 1 1 0 1 1 0 0;
      0 0 1 1 1 1 1 1 0 0 0;
      0 0 0 1 0 1 1 1 0 0 0;
      0 0 0 0 1 1 1 1 1 1 0;
      0 0 0 0 1 0 0 1 1 1 1;
      0 0 0 0 0 0 0 1 1 1 1;
      0 0 0 0 0 0 0 0 1 1 1 ];
c = length(C);

% objective function is sum(x)
n = 11;
x = symbolic('x', 1, n);

% create the proposition to check
p = true;
for i = 1:n
    p = p && 0 <= x(i) && x(i) <= 1;
end

for i = 1:c
    p = p && 1 <= dot(C(i,:), x) && dot(C(i,:), x) <= n;
end

% find a feasible point
msg = 'solving...'
[r,z] = check_sat(p);
z

% solution x: [0 1 0 0 0 0 1 0 0 0 1]
% value of the objective function here is 3

% now add a new constraint that the objective function is smaller than 3
msg = 'adding new constraint...'
p = p && 0 <= sum(x) && sum(x) <= 2;
msg = 'solving...'
[r,z] = check_sat(p);
if r == 0
    msg = 'no solution!'
end

% so we know the feasible point found is optimal


