
% This file describe the problem of finding a glider that moves
% from one state to another.
start_state = [
  '_________'
  '_________'
  '__0000000'
    0000000'
  '______0110000'
  '______0110000'
  '______0000000'
  '______0110000'
  '______0110000'
  '______0000000'
]


end_state = [
  '0000000000___'
  '0000000110___'
  '0000000110___'
  '0000000000__1'
  '0000000110___'
  '0000000110___'
  '0000000000___'
]

%{
start_state = [
  '______000000000'
  '______011000000'
  '______011000000'
  '______000000000'
  '______011000000'
  '______011000000'
  '______000000000'
  '______011000000'
  '______011000000'
  '______000000000'
]


end_state = [
  '0000000000_____'
  '0000000110_____'
  '0000000110____1'
  '0000000000_____'
  '0000000110_____'
  '0000000110_____'
  '0000000000_____'
  '0000000110____1'
  '0000000110_____'
  '0000000000_____'
]
%}

max_iter = 40;

%conway = @conway_step;
conway = @conway_bit;

%mss_config('default_solver', 'abc')
%mss_config('default_solver', 'yices')
%mss_config('default_solver', 'boolector')
mss_config('default_solver', 'z3')

% Create symbolic variables for garden of eden.
x = symbolic('x', size(start_state), 'logical')


c0 = sat_constraints(x, start_state)

total = 0;
y = x;
for i = 1:max_iter
  i
  y = conway(y);
  c1 = sat_constraints(y, end_state);
  start = clock;
  [r,s] = check_sat(c0 & c1);
  total = total + etime(clock, start)
  r
  if r
    total
    s.x
    rep(conway, i, s.x)
    break;
  end
end