
% This file describe the problem of finding a glider that moves
% from one state to another.

start_state = [
  '000000'
  '000000'
  '000000'
  '___000'
  '_1_000'
  '___000'
]

end_state = [
  '000_11'
  '000_11'
  '000___'
  '000000'
  '000000'
  '000000'
]

max_iter = 20;

% Create symbolic variables for garden of eden.
x = symbolic('x', size(start_state), 'logical')

%conway = @conway_step;
conway = @conway_bit;

%mss_config('default_solver', 'z3')
mss_config('default_solver', 'abc')

c0 = sat_constraints(x, start_state)

y = x;
for i = 1:max_iter
  i
  y = conway(y);
  c1 = sat_constraints(y, end_state);
  [r,s] = check_sat(c0 & c1);
  r
  if r
    s.x
    rep(conway, i, s.x)
    break;
  end
end