mss_config('default_solver', 'blt')
mss_config('blt_params', '-s 268435456');  % magic # is 2^28

luminance_quant_tbl = [ 16,  11,  10,  16,  24,  40,  51,  61
                        12,  12,  14,  19,  26,  58,  60,  55
                        14,  13,  16,  24,  40,  57,  69,  56
                        14,  17,  22,  29,  51,  87,  80,  62
                        18,  22,  37,  56,  68, 109, 103,  77
                        24,  35,  55,  64,  81, 104, 113,  92
                        49,  64,  78,  87, 103, 121, 120, 101
                        72,  92,  95,  98, 112, 100, 103,  99 ];

lvl = 50;
q = quantization_matrix(lvl, luminance_quant_tbl);

x = symbolic('x', 8, 8, 'integer');
y = my_dct2(q .* x);

c = { 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
      'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
      'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
      'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
      'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
      'xx' '36' '81' 'b4' '90' '66' '47' 'xx'
      'xx' '70' 'b4' '84' '70' '66' '85' 'xx'
      'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' };

[l,h] = bounds(c)

[r,c] = check_sat(l <= y & y <= h)

msg = 'Checking solution...'
if r == 1
    c.x
    y = my_dct2(q .* c.x)
    o = l <= y & y <= h
end
