% Generate integer coefficients for problem.
coef = symbolic('coef', 8, 8, 'integer')

% Set the quantization levels the we attempt to solve under. Note: the
% level has a significant effect on the satisfiability of the problem.
% Levels above 40 are known to be SAT whereas several levels below 10 are
% known to be UNSAT.
lvls = [50 60 70];
%lvls = [100 90 80 70 60 50 40];
%lvls = [99:-1:30];
%lvls = [1:30];  % these will take a very long time
%lvls = [29]

constraints = { 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
                'xx' '48' '65' '6c' '6c' '6f' '20' 'xx' % Hello
                'xx' '57' '6f' '72' '6c' '64' '21' 'xx' % World
                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' };

% More constraints
%
%constraints = { 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
%                'xx' '48' '65' '6c' '6c' '6f' '20' 'xx' % Hello
%                'xx' '57' '6f' '72' '6c' '64' '21' 'xx' % World
%                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
%                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx'
%                'xx' '48' '65' '6c' '6c' '6f' '20' 'xx' % Hello
%                'xx' '57' '6f' '72' '6c' '64' '21' 'xx' % World
%                'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' 'xx' };

[l,h] = bounds(0, 255, constraints);

mss_config('default_solver', 'blt');
% Use 28 bits of precision
mss_config('blt_params', ['-s ' num2str(2^28)]);

run_times = []
run_lvls = []
for lvl=lvls
    lvl

    q = luminance_quantization_matrix(lvl);
    img = my_idct2(q .* coef);
    p = l <= img & img <= h;

    msg = 'Running check_sat...'
    start = clock;
    [r,c] = check_sat(p);
    time = etime(clock, start)

    run_lvls = [run_lvls lvl]
    run_times =[run_times time]

    if r == 1
        msg = 'Checking solution...'
        c.coef;
        y = my_idct2(q .* c.coef);
        o = l <= y & y <= h;
        test_check(o);
    else
        msg = 'No solution found...'
    end
end

lvls
run_times
