mss_config('default_solver', 'blt')
mss_config('blt_params', '-p 32')

% problem parameters
n = 10;        % dimension
l(1:n) = -10;  % lower bounds
h(1:n) = 10;   % upper bounds
s = 1;         % quantization scale

% tight constraint on some components
l(3) = 17;    h(3) = 18;
l(5) = 100;   h(5) = 101;
l(7) = -235;  h(7) = -234;
l(n-1) = -10; h(n-1) = -9;

% compute scaled & rounded idct
x = symbolic('x', 1, n, 'integer');
y = q_idct(s, x);

% run solver
[r,c] = check_sat(l <= y & y <= h)

% check the solution
msg = 'Checking solution...'
if r == 1
  c.x
  y = q_idct(s, c.x)
  o = l <= y & y <= h
end
