#include <stdio.h>
#include <sym-api.h>

const int sz = 11;

int find_majority( int* arr, int n );

int main()
{
  int* arr = (int*) mss_fresh_uint32_array( "x", sz );

  // Assume that 'maj' is the majority element
  int maj = mss_fresh_uint32( "maj" );
  int count = 0;
  for( int i=0; i<sz; i++ ) {
    if( maj == arr[i] ) { count++; }
  }
  mss_assume( (2*count) > sz );

  // Call the algorithm
  int c = find_majority( arr, sz );
  mss_assert( c == maj );

  uint32_t num;
  uint32_t* ps = mss_proof_obligations( &num );

  printf("Proof obligations: %d\n", num );

  for( int i=0; i<num; i++ ) {
    printf("Attempting proof for obligation %d\n", i );
    //mss_print_symbolic_uint32( ps[i] );

    struct mss_model* mdl = mss_check_sat_raw( ps[i] );
    if( mdl ) {
      printf( "Counterexample for obligation %d\n", i );
      mss_print_model(mdl);
    } else {
      printf( "Obligation %d proved!\n", i );
    }
    free(mdl);
  }

  free(ps);
}
