% areas.m
%
% This example demonstrates some of the basic object oriented functionality
%

%%%%%%%%%%%%%

r = Rectangle;     % construct an object whose class inherits from Shape
r.w = 2; r.h = 3;  % set properties

msg = r.to_str()         % print the name of the shape
r.area()           % invoke a method, ans = 6

%%%%%%%%%%%%%

t = Triangle;      % object from a different subclass of Shape
t.w = 2; t.h = 3;

t.to_str()
t.area()           % ans = 3

t = t.setw(3);     % call a setter

t.area()           % ans = 4.5

%%%%%%%%%%%%%

ft = FilledTriangle;
ft.w = 1; ft.h = 1;
ft = ft.setcolor('Purple');

ft

ft.to_str()
ft.area()
