% Compute sliding average
% 'width' is the size of the window
% 'shift' is how much to shift the window
% shift must be less than width (ie windows overlap)
function y = slide(x,width,shift)
  nx = size(x,2);
  ny = ceil ((nx-width+1)/shift);
  y = zeros(1,ny);

  i = 1;
  for j = 1:ny
    seg = x(i:(i+width-1));
    y(j) = sum(seg) / width;
    i = i + shift;
  end
end

% Assertion that relates sucessive windows 
% if j > 1
  % assert(y(j) == y(j-1) - sum(x(i-shift:i-1)) + sum(x(i+width-shift:i+width-1)));
% end
